# class ActionDispatch::Session::CacheStore

Session store that uses an ActiveSupport::Cache::Store to store the sessions. This store is most useful if you don’t store critical data in your sessions and you don’t need them to live for extended periods of time.

### Public Class Methods

new(app, options = {}) click to toggle source

Create a new store. The cache to use can be passed in the `:cache` option. If it is not specified, `Rails.cache` will be used.

Calls superclass method

    # File lib/action_dispatch/middleware/session/cache_store.rb, line 11
    def initialize(app, options = {})
      @cache = options[:cache] || Rails.cache
      options[:expire_after] ||= @cache.options[:expires_in]
      super
    end

### Public Instance Methods

destroy_session(env, sid, options) click to toggle source

Remove a session from the cache.

    # File lib/action_dispatch/middleware/session/cache_store.rb, line 37
    def destroy_session(env, sid, options)
      @cache.delete(cache_key(sid))
      generate_sid
    end

get_session(env, sid) click to toggle source

Get a session from the cache.

    # File lib/action_dispatch/middleware/session/cache_store.rb, line 18
    def get_session(env, sid)
      sid ||= generate_sid
      session = @cache.read(cache_key(sid))
      session ||= {}
      [sid, session]
    end

set_session(env, sid, session, options) click to toggle source

Set a session in the cache.

    # File lib/action_dispatch/middleware/session/cache_store.rb, line 26
    def set_session(env, sid, session, options)
      key = cache_key(sid)
      if session
        @cache.write(key, session, :expires_in => options[:expire_after])
      else
        @cache.delete(key)
      end
      sid
    end